heapPreview = {};
heapPreview.modDir = g_currentModDirectory;
heapPreview.settingsDir = getUserProfileAppPath().. "moV2Hud_Settings/";

heapPreview.metadata = {
	interface = " FS17 1.x",
	title = " HeapPreview",
	notes = " Zeigt Aktuelle Füllstände der Haufen an und Speichert diese optional für den MultiOverlayV2 Hud Mod",
	author = " (by HappyLooser)",
	version = " v0.5 Beta",	
	datum = " 24.11.2016",
	update = " 04.12.2016",
	web = " http://www.minetropolis.de/",
	info = " Link Freigabe,Änderungen,Kopien oder Code Benutzung ist ohne meine Zustimmung nicht erlaubt",
	"##Orginal Link Freigabe:"
};

heapPreview.values = {	
	height = 5,
	radius = 30.0,	
	onSaveForMoh = false,
	distance = 20,
	onFoot = true,
	onVehicle = false, 
	onField = false,
	foundHeap = false,
	fillTypeName = "",
	fillType = 0,
	fillLevel = 0,	
	hx = 0,
	hy = 0;
	hz = 0,
	px = 0,
	py = 0,
	pz = 0,
	widthX = 0,
	widthZ = 0,
	heightX = 0,
	heightZ = 0,
	foundMoh = false,
	onStartCheck = true,
	heapDebug = 0,
	heapDebugTxt = {" Off", " Radius", " SavePos", " DistanceOnSave", " All"},
};


function heapPreview:loadMap(name)		
	print("---loading".. tostring(heapPreview.metadata.title).. tostring(heapPreview.metadata.version).. tostring(heapPreview.metadata.author).. "---")
	loadConfig();
end;

function heapPreview:deleteMap()
	saveHeaps();
	saveConfig();
end;

function heapPreview:mouseEvent(posX, posY, isDown, isUp, button)	
end;

function heapPreview:keyEvent(unicode, sym, modifier, isDown)	
	if getFullSize() or getIngameMap() or getServer() then return;end;
	if heapPreview.values.foundMoh and heapPreview.values.onSaveForMoh and InputBinding.isPressed(InputBinding.heapSave) then
		if not isSaveHeapForMoh() then saveHeapForMoh();else isSaveHeapForMoh(true);end; --deleteHeapForMoh();end;
	end;
	if InputBinding.isPressed(InputBinding.heapDebug) then
		heapPreview.values.heapDebug = heapPreview.values.heapDebug+1;
		if heapPreview.values.heapDebug > 4 or (not heapPreview.values.onSaveForMoh and heapPreview.values.heapDebug > 1) or (not heapPreview.values.foundMoh and heapPreview.values.heapDebug > 1)then heapPreview.values.heapDebug = 0;end;
	end;
end;

function heapPreview:updateTick(dt)		
end;

function heapPreview:update(dt)	
	if getFullSize() or getIngameMap() or getServer() then return;end;
	if heapPreview.values.onStartCheck then searchMoh();end;
	searchHeaps();
	if InputBinding.hasEvent(InputBinding.heapDebug) then
		return;
	end;
	if heapPreview.values.foundHeap then
		local debugTxt = " (Debug:".. tostring(heapPreview.values.heapDebug).. tostring(heapPreview.values.heapDebugTxt[heapPreview.values.heapDebug+1]).. ")";		
		g_currentMission:addExtraPrintText(g_i18n:getText("info_fillLevel").. " ".. tostring(heapPreview.values.fillTypeName).. " | ".. tostring(g_i18n:formatNumber(heapPreview.values.fillLevel)).. "L".. tostring(debugTxt));		
		if heapPreview.values.foundMoh and heapPreview.values.onSaveForMoh then			
			if not isSaveHeapForMoh() then g_currentMission:addHelpButtonText("Save Heap for MultiOverlayV2 Mod", InputBinding.heapSave, nil, GS_PRIO_NORMAL);else g_currentMission:addHelpButtonText("Delete Heap for MultiOverlayV2 Mod", InputBinding.heapSave, nil, GS_PRIO_NORMAL);end;
			if InputBinding.hasEvent(InputBinding.heapSave) then
				return;
			end;			
		end;
	end;		
end;

function heapPreview:draw()
	if getFullSize() or getIngameMap() or getServer() then return;end;
	if heapPreview.values.heapDebug == 1 or (heapPreview.values.foundMoh and heapPreview.values.onSaveForMoh and (heapPreview.values.heapDebug == 2 or heapPreview.values.heapDebug == 3 or heapPreview.values.heapDebug == 4 ))then
		if g_currentMission.heapPreview ~= nil and #g_currentMission.heapPreview > 0 then			
			for a=1, #g_currentMission.heapPreview do
				--drawDebugPoint(g_currentMission.heapPreview[a].px+1, g_currentMission.heapPreview[a].py+1, g_currentMission.heapPreview[a].pz+1, 0, 150 , 50, 150);				
				setDebugDraw(g_currentMission.heapPreview[a]);
				--DebugUtil.drawDebugNode(integer id, "TEST");
			end;
			if heapPreview.values.heapDebug == 1 then setDebugDraw(heapPreview.values);end;
		else
			setDebugDraw(heapPreview.values);
		end;
	end;
	--searchHeaps();	
end;
addModEventListener(heapPreview);

function setDebugDraw(heapTable)
	if heapPreview.values.heapDebug == 1 then
		DebugUtil.drawDebugCircle(heapTable.px, heapTable.py+0.6, heapTable.pz, heapPreview.values.radius, 50);		
	elseif heapPreview.values.heapDebug == 2 then
		drawDebugLine(heapTable.px, heapTable.py-1, heapTable.pz, 0, 50, 50, heapTable.px, heapTable.py+1, heapTable.pz, 0, 50, 50);
	elseif heapPreview.values.heapDebug == 3 then
		DebugUtil.drawDebugCircle(heapTable.px, heapTable.py+0.05, heapTable.pz, heapPreview.values.distance, 50);
	elseif heapPreview.values.heapDebug == 4 then
		drawDebugLine(heapTable.px, heapTable.py-1, heapTable.pz, 0, 50, 50, heapTable.px, heapTable.py+1, heapTable.pz, 0, 50, 50);
		DebugUtil.drawDebugCircle(heapTable.px, heapTable.py+0.05, heapTable.pz, heapPreview.values.distance, 50);
		DebugUtil.drawDebugCircle(heapTable.px, heapTable.py+0.6, heapTable.pz, heapPreview.values.radius, 50);
	end;
end;

function setGetValues(delete, fillType, fillTypeName, fillLevel, x, y, z, widthX, widthZ, heightX, heightZ, pX, pY, pZ)
	if delete then
		heapPreview.values.foundHeap = false;
		heapPreview.values.fillType = 0;
		heapPreview.values.fillLevel = 0;
		heapPreview.values.fillTypeName = "";
		heapPreview.values.hx = 0;
		heapPreview.values.hy = 0;
		heapPreview.values.hz = 0;
		heapPreview.values.px = 0;
		heapPreview.values.py = 0;
		heapPreview.values.pz = 0;
		heapPreview.values.widthX = 0;
		heapPreview.values.widthZ = 0;
		heapPreview.values.heightX = 0;
		heapPreview.values.heightZ = 0;
	else
		heapPreview.values.fillType = fillType;
		heapPreview.values.fillTypeName = fillTypeName;
		heapPreview.values.fillLevel = fillLevel;
		heapPreview.values.hx = x;
		heapPreview.values.hy = y;
		heapPreview.values.hz = z;
		heapPreview.values.px = pX;
		heapPreview.values.py = pY;
		heapPreview.values.pz = pZ;
		heapPreview.values.widthX = widthX;
		heapPreview.values.widthZ = widthZ;
		heapPreview.values.heightX = heightX;
		heapPreview.values.heightZ = heightZ;
		heapPreview.values.foundHeap = true;		
	end;
end;

function getFillTypeName(fillType)
	local name = "Unknown"; --FillUtil.getFillTypesByNames(fillType, "Unknown");
	local desc = FillUtil.fillTypeIndexToDesc[fillType];
	if desc ~= nil then 
		if g_i18n:hasText(desc.nameI18N) then
			name = g_i18n:getText(desc.nameI18N);
		else
			name = desc.nameI18N
		end;
	end;
	return name;
end;

function getFullSize()
	if g_currentMission.paused or 
	g_currentMission.manualPaused or 
	g_currentMission.physicsPaused then 
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.manualPaused then return false;end; --patch 1.3 MP bug !!
	return true;end;
	return false;
end;

function getIngameMap()
	if g_currentMission.ingameMap.isVisible and g_currentMission.ingameMap.state == 1 
	then return true;end;
	return false;
end;

function getServer()
	if g_server ~= nil and g_client ~= nil then return false;end;	
	return true;
end;

function searchMoh()	
	local env = getfenv(0);	
	for modName,isLoaded in pairs(g_modIsLoaded) do		
		if isLoaded and modName == "MultiOverlayV2" then			
			heapPreview.values.onStartCheck = false;
			if g_currentMission.heapPreview == nil then 
				print("---".. tostring(heapPreview.metadata.title).. " --> not found MultiOverlayV2 Hud v2.84 or higher(save Heaps for MultiOverlayV2 Hud not ready)---")
				return false;
			end; 
			--g_currentMission.heapPreview = {};
			heapPreview.values.foundMoh = true;
			loadHeaps();
			print("---".. tostring(heapPreview.metadata.title).. " --> found MultiOverlayV2 Hud---")
			print("--- set optional objectSettings.xml <map> modType=ls,slotType=optional,category=heaps,xmlString=heaps,separated=true,isHiden=false,displayName=Heaps(ls) <map/>---")
			return true;			
		end	
	end;
	heapPreview.values.onStartCheck = false;
	print("---".. tostring(heapPreview.metadata.title).. " not found MultiOverlayV2 Hud 2.84 or higher(save Heaps for MultiOverlayV2 Hud not ready)---")	
	return false;
end;

function getIsOnField(x,y,z)    
    local densityBits = getDensityAtWorldPos(g_currentMission.terrainDetailId, x, y, z);
    return densityBits ~= 0;
end;

function searchHeaps()
	local x, y, z, rootNode = isHeapDraw();		
	if x ~= nil and y ~= nil and z ~= nil and rootNode ~= nil then		
		local radius = heapPreview.values.radius;		
		--rotate next update check x3....
		local x0,y0,z0 = localToWorld(rootNode, x + radius, y, z - radius);
        local x1,y1,z1 = localToWorld(rootNode, x - radius, y, z - radius);
        local x2,y2,z2 = localToWorld(rootNode, x + radius, y, z + radius);
		local x3,y3,z3 = localToWorld(rootNode, x - radius, y, z + radius); 
		local hx, hz, widthX, widthZ, heightX, heightZ = Utils.getXZWidthAndHeight(nil, x0,z0, x1,z1, x2,z2);
		local xS1, zS1, widthX1, widthZ1, heightX1, heightZ1 = Utils.getXZWidthAndHeight(nil, x2,z2, x1,z1, x0,z0); ---height limit 4 meter	,check rotate next...	
		local height = heapPreview.values.height; --TipUtil.getHeightAtWorldPos(x, y, z);
		local fillType = TipUtil.getFillTypeAtLine(x, y, z, x, y, z, radius);
		local fillLevel = nil;		
		if fillType ~= nil and fillType ~= 0 then			
			fillLevel = TipUtil.getFillLevelAtArea(fillType, hx, hz, widthX, widthZ, heightX, heightZ);			
		end;
		if fillLevel ~= nil and fillLevel ~= 0 then			
			setGetValues(false, fillType, getFillTypeName(fillType), fillLevel, hx, y, hz, widthX, widthZ, heightX, heightZ, x, y, z);			
		else
			setGetValues(true);
		end;
	else
		setGetValues(true);
	end;
end;

function saveHeapForMoh()
	if g_currentMission.heapPreview ~= nil then
		table.insert(g_currentMission.heapPreview, {fillType=heapPreview.values.fillType, fillTypeName=heapPreview.values.fillTypeName, hx=heapPreview.values.hx, hy=heapPreview.values.hy, hz=heapPreview.values.hz, widthX=heapPreview.values.widthX, widthZ=heapPreview.values.widthZ, heightX=heapPreview.values.heightX, heightZ=heapPreview.values.heightZ, px=heapPreview.values.px, py=heapPreview.values.py, pz=heapPreview.values.pz});
		saveHeaps();				
		--g_currentMission:showBlinkingWarning("save Heap for MultiOverlay Mod", 1500);
	end;
end;

function deleteHeapForMoh()
	if g_currentMission.heapPreview ~= nil and #g_currentMission.heapPreview > 0 then
		for a=1, #g_currentMission.heapPreview do
			if g_currentMission.heapPreview[a].hx == heapPreview.values.hx and g_currentMission.heapPreview[a].hy == heapPreview.values.hy then
				table.remove(g_currentMission.heapPreview, a);
				break;
			end;
		end;
	end;
end;

function isHeapDraw()	
	---next Update check TipReferenz for active Trailer LEFT/Right etc.
	local x, y, z;
	local rootNode;
	local onVehicle = false;
	if heapPreview.values.onVehicle and (g_currentMission.controlledVehicle ~= nil and g_currentMission.controlledVehicle.controllerName == g_currentMission.player.controllerName) then
		--if g_currentMission.controlledVehicle.components ~= nil and g_currentMission.controlledVehicle.components[1] ~= nil and g_currentMission.controlledVehicle.components[1].node ~= nil then					
			--x, y, z = getWorldTranslation(g_currentMission.controlledVehicle.components[1].node);
			--rootNode = g_currentMission.controlledVehicle.components[1].node;
			x, y, z = getWorldTranslation(g_currentMission.controlledVehicle.rootNode);
			rootNode = g_currentMission.controlledVehicle.rootNode;
			onVehicle = true;
		--end;
	end;
	if not onVehicle then x, y, z = getWorldTranslation(g_currentMission.player.rootNode);rootNode = Utils.getNoNil(g_currentMission.player.rootNode, nil);end;
	if not heapPreview.values.onField and getIsOnField(x,y,z) then return nil, nil, nil, nil;end;
	if onVehicle and heapPreview.values.onVehicle then return x, y, z, rootNode;end;
	if not onVehicle and heapPreview.values.onFoot then return x, y, z, rootNode;end;
	return nil, nil, nil, nil;
end;

function isSaveHeapForMoh(delete)
	local foundSave = false
	if g_currentMission.heapPreview ~= nil and #g_currentMission.heapPreview > 0 then
		for a=1, #g_currentMission.heapPreview do
			local pX = g_currentMission.heapPreview[a].px;
			local pY = g_currentMission.heapPreview[a].py;
			local pZ = g_currentMission.heapPreview[a].pz;
			local fillType = g_currentMission.heapPreview[a].fillType;
			local pX1 = heapPreview.values.px;
			local pY1 = heapPreview.values.py;
			local pZ1 = heapPreview.values.pz			
			local distance = Utils.vector3Length(pX-pX1, pY-pY1, pZ-pZ1);			
			local fillLevel = TipUtil.getFillLevelAtArea(fillType, g_currentMission.heapPreview[a].hx, g_currentMission.heapPreview[a].hz, g_currentMission.heapPreview[a].widthX, g_currentMission.heapPreview[a].widthZ, g_currentMission.heapPreview[a].heightX, g_currentMission.heapPreview[a].heightZ);
			if fillLevel == 0 then table.remove(g_currentMission.heapPreview, a);saveHeaps();end;
			if distance <= heapPreview.values.distance or (pX == pX1 and pZ == pZ1) then				
				if (delete ~= nil and delete) then
					if fillLevel ~= 0 then table.remove(g_currentMission.heapPreview, a);end;					
					--g_currentMission:showBlinkingWarning("delete Heap", 1500);
					foundSave = false;
					setGetValues(true);
					saveHeaps();
					break;
				end;			
				--g_currentMission:showBlinkingWarning("not delete Heap", 1500);
				--if fillType ~= heapPreview.values.fillType then break;end;
				foundSave = true;
				break;
			end;
		end;
	end;
	return foundSave;
end;

function loadConfig()
	local path = getUserProfileAppPath();		
	local file = path.."heapPreviewSettings.xml";		
	local Xml;
	if not getServer() then		
		if not fileExists(file) then
			print(tostring(heapPreview.metadata.title).. " generated heapPreviewSettings.xml file")
			saveConfig();												
		else			
			print("loading "..file.." for heapPreview settings");		
			Xml = loadXMLFile("heapPreviewSettings_XML", file, "heapPreview");
			local xmlNameTag = ("heapPreview.values(%d)"):format(0);
			if getXMLBool(Xml, xmlNameTag.."#onSaveForMoh") ~= nil then heapPreview.values.onSaveForMoh = getXMLBool(Xml, xmlNameTag.."#onSaveForMoh");end;
			if getXMLBool(Xml, xmlNameTag.."#onFoot") ~= nil then heapPreview.values.onFoot = getXMLBool(Xml, xmlNameTag.."#onFoot");end;
			if getXMLBool(Xml, xmlNameTag.."#onVehicle") ~= nil then heapPreview.values.onVehicle = getXMLBool(Xml, xmlNameTag.."#onVehicle");end;
			if getXMLBool(Xml, xmlNameTag.."#onField") ~= nil then heapPreview.values.onField = getXMLBool(Xml, xmlNameTag.."#onField");end;			
			if getXMLInt(Xml, xmlNameTag.."#distanceOnSave") then heapPreview.values.distance = getXMLInt(Xml, xmlNameTag.."#distanceOnSave");end;
			if getXMLInt(Xml, xmlNameTag.."#debug") then heapPreview.values.heapDebug = getXMLInt(Xml, xmlNameTag.."#debug");end;
			if getXMLFloat(Xml, xmlNameTag.."#radius") then heapPreview.values.radius = getXMLFloat(Xml, xmlNameTag.."#radius");end;
			saveXMLFile(Xml);
		end;		
	end;
end;

function saveConfig()
	local path = getUserProfileAppPath();		
	local file = path.."heapPreviewSettings.xml";
	local Xml = createXMLFile("heapPreviewSettings_XML", file, "heapPreview");		
	local xmlNameTag = ("heapPreview.values(%d)"):format(0);			
	--setXMLInt(Xml, xmlNameTag.."#height", heapPreview.values.height);
	setXMLInt(Xml, xmlNameTag.."#debug", heapPreview.values.heapDebug);
	setXMLFloat(Xml, xmlNameTag.."#radius", heapPreview.values.radius);
	setXMLInt(Xml, xmlNameTag.."#distanceOnSave", heapPreview.values.distance);	
	setXMLBool(Xml, xmlNameTag.."#onSaveForMoh", heapPreview.values.onSaveForMoh);
	setXMLBool(Xml, xmlNameTag.."#onFoot", heapPreview.values.onFoot);
	setXMLBool(Xml, xmlNameTag.."#onVehicle", heapPreview.values.onVehicle);
	setXMLBool(Xml, xmlNameTag.."#onField", heapPreview.values.onField);
	saveXMLFile(Xml);		
end;

function loadHeaps()	
	local saveGameDir = heapPreview.settingsDir.. "savegame".. g_currentMission.missionInfo.savegameIndex.. "/heapPreviewMoh.xml"; 	
	if not fileExists(saveGameDir) then return;end;
	local Xml = loadXMLFile("heapPreviewMoh_XML", saveGameDir, "heapPreviewMoh");	
	if g_currentMission.heapPreview ~= nil then		
		for a=1, 500 do
			local xmlNameTag = ("heapPreviewMoh.values(%d)"):format(a-1);
			local idx = getXMLInt(Xml, xmlNameTag.."#heap");
			if idx == nil or xmlNameTag == nil then				
				break;
			end;
			local fillTypeName = "";
			local fillType = 0;
			local hx = 0;
			local hy = 0;
			local widthX = 0;
			local widthZ = 0;
			local heightX = 0;
			local heightZ = 0;
			local pX = 0;
			local pY = 0;
			local pZ = 0;
			--if getXMLString(Xml, xmlNameTag.."#fillTypeName") then fillTypeName = getXMLString(Xml, xmlNameTag.."#fillTypeName");end;
			if getXMLInt(Xml, xmlNameTag.."#fillType") then fillType = getXMLInt(Xml, xmlNameTag.."#fillType");end;
			if getXMLFloat(Xml, xmlNameTag.."#hx") then hx = getXMLFloat(Xml, xmlNameTag.."#hx");end;
			if getXMLFloat(Xml, xmlNameTag.."#hy") then hy = getXMLFloat(Xml, xmlNameTag.."#hy");end;
			if getXMLFloat(Xml, xmlNameTag.."#hz") then hz = getXMLFloat(Xml, xmlNameTag.."#hz");end;
			if getXMLFloat(Xml, xmlNameTag.."#widthX") then widthX = getXMLFloat(Xml, xmlNameTag.."#widthX");end;
			if getXMLFloat(Xml, xmlNameTag.."#widthZ") then widthZ = getXMLFloat(Xml, xmlNameTag.."#widthZ");end;
			if getXMLFloat(Xml, xmlNameTag.."#heightX") then heightX = getXMLFloat(Xml, xmlNameTag.."#heightX");end;
			if getXMLFloat(Xml, xmlNameTag.."#heightZ") then heightZ = getXMLFloat(Xml, xmlNameTag.."#heightZ");end;
			if getXMLFloat(Xml, xmlNameTag.."#px") then pX = getXMLFloat(Xml, xmlNameTag.."#px");end;
			if getXMLFloat(Xml, xmlNameTag.."#py") then pY = getXMLFloat(Xml, xmlNameTag.."#py");end;
			if getXMLFloat(Xml, xmlNameTag.."#pz") then pZ = getXMLFloat(Xml, xmlNameTag.."#pz");end;
			local fillLevel = TipUtil.getFillLevelAtArea(fillType, hx, hz, widthX, widthZ, heightX, heightZ);
			if fillLevel == nil or fillLevel == 0 then
			else
				table.insert(g_currentMission.heapPreview, {fillType=fillType, fillTypeName=fillTypeName, hx=hx, hy=hy, hz=hz, widthX=widthX, widthZ=widthZ, heightX=heightX, heightZ=heightZ, px=pX, py=pY, pz=pZ});
			end;
		end;
		saveHeaps();
	end;
end;

function saveHeaps()
	if not fileExists(heapPreview.settingsDir) then createFolder(heapPreview.settingsDir);end;		
	if not fileExists(heapPreview.settingsDir.. "savegame".. g_currentMission.missionInfo.savegameIndex.."/") then createFolder(heapPreview.settingsDir.. "savegame".. g_currentMission.missionInfo.savegameIndex.."/");end;
	local saveGameDir = heapPreview.settingsDir.. "savegame".. g_currentMission.missionInfo.savegameIndex.. "/heapPreviewMoh.xml"; 
	if g_currentMission.heapPreview ~= nil and #g_currentMission.heapPreview > 0 then
		local Xml = createXMLFile("heapPreviewMoh_XML", saveGameDir, "heapPreviewMoh");
		for a=1, #g_currentMission.heapPreview do
			local xmlNameTag = ("heapPreviewMoh.values(%d)"):format(a-1);
			setXMLInt(Xml, xmlNameTag.."#heap", a);
			--setXMLString(Xml, xmlNameTag.."#fillTypeName", g_currentMission.heapPreview[a].fillTypeName);
			setXMLInt(Xml, xmlNameTag.."#fillType", g_currentMission.heapPreview[a].fillType);
			setXMLFloat(Xml, xmlNameTag.."#hx", g_currentMission.heapPreview[a].hx);
			setXMLFloat(Xml, xmlNameTag.."#hy", g_currentMission.heapPreview[a].hy);
			setXMLFloat(Xml, xmlNameTag.."#hz", g_currentMission.heapPreview[a].hz);
			setXMLFloat(Xml, xmlNameTag.."#widthX", g_currentMission.heapPreview[a].widthX);
			setXMLFloat(Xml, xmlNameTag.."#widthZ", g_currentMission.heapPreview[a].widthZ);
			setXMLFloat(Xml, xmlNameTag.."#heightX", g_currentMission.heapPreview[a].heightX);
			setXMLFloat(Xml, xmlNameTag.."#heightZ", g_currentMission.heapPreview[a].heightZ);
			setXMLFloat(Xml, xmlNameTag.."#px", g_currentMission.heapPreview[a].px);
			setXMLFloat(Xml, xmlNameTag.."#py", g_currentMission.heapPreview[a].py);
			setXMLFloat(Xml, xmlNameTag.."#pz", g_currentMission.heapPreview[a].pz);
		end;
		saveXMLFile(Xml);
	end;	
end;